window.addEventListener(
    'message',
    async (event) => {        
        if(clip_transparent_object.mode === 'test') console.log('Mensaje recibido:', event);

        if (event.origin === clip_transparent_object.threeds) {
            if(clip_transparent_object.mode === 'test') console.log('El origen del mensaje coincide con el dominio esperado.');

        const paymentId = event.data?.paymentId;
        if (paymentId) {
            if(clip_transparent_object.mode === 'test') console.log('Se recibió un paymentId:', paymentId);

            var dataToSend = {
            action: "clip_transparent_3ds_complete",
            nonce: clip_transparent_object.nonce,
            order_id: clip_transparent_object.order_id,
            payment_id: paymentId,
            }

            jQuery.post(clip_transparent_object.admin_ajax, dataToSend, function (response) {
                if (response.success) {
                    if(clip_transparent_object.mode === 'test') console.log(response);
                    window.location.replace(response.data.redirect);  
                }
            });            
            // executePolling(paymentId);
        } else {
            if(clip_transparent_object.mode === 'test') console.log('No se proporcionó un paymentId en el mensaje.');            
            // notifyPaymentIdNotProvided();
        }
        } else {
            if(clip_transparent_object.mode === 'test') console.log('El origen del mensaje no coincide con el dominio esperado.');
        }
    },
    false
);