if(clip_transparent_object.mode === 'test') console.log("init clip payment sdk");
jQuery(document).ready(function($) {
    $(window).on('load', function() {
        if(clip_transparent_object.mode === 'test') console.log("page loaded");
        setTimeout(function() {
            if (typeof API_KEY === 'undefined') {
                let CARD;
                jQuery(document.body).trigger('update_checkout');

                verificarCheckbox();

                jQuery('#payment_method_wc_clip_transparent').change(function() {
                    verificarCheckbox();
                });

                function verificarCheckbox() {
                    if(clip_transparent_object.mode === 'test') console.log("verify checkbox");
                    if (jQuery('#payment_method_wc_clip_transparent').prop('checked')) {
                        if(clip_transparent_object.mode === 'test') console.log('El checkbox está chequeado.');
                        const content = document.getElementById('card-element');                        
                        if (content.children.length > 0) {
                            content.removeChild(content.children[0])
                        }

                        var dataToSend = {
                            action: "clip_transparent_cart_total",
                            nonce: clip_transparent_object.nonce,
                        }
                        jQuery.post(clip_transparent_object.admin_ajax, dataToSend, function(response) {
                            if (response.success) {
                                if(clip_transparent_object.mode === 'test') console.log(response);
                                if(clip_transparent_object.mode === 'test') console.log(response.data);
                                crearCardMount(response.data);
                            }
                        });
                    }
                }

                function crearCardMount(price) {
                    if(clip_transparent_object.mode === 'test') console.log("crearCardMount");
                    if(clip_transparent_object.mode === 'test') console.log(price);
                    const API_KEY = clip_transparent_object.api_key;
                    var clip;
                    if(clip_transparent_object.mode === 'test'){
                        clip = new ClipSDK(API_KEY, {
                            env: "dev"
                        }); 
                    } else {
                        clip = new ClipSDK(API_KEY, {});
                    }
                    
                    CARD = clip.element.create("Card", { // Asignar a la variable card
                        theme: clip_transparent_object.theme_options,
                        locale: clip_transparent_object.locale_options,
                        paymentAmount: price,
                        terms: {
                            enabled: true
                        }
                    });
                    if(clip_transparent_object.mode === 'test') console.log(CARD);
                    if(clip_transparent_object.mode === 'test') console.log(jQuery("#card-element"));
                    CARD.mount("card-element");
                }


                jQuery(document).ready(function($) {

                    $('#place_order').on('click', async function(event) {
                        event.preventDefault();

                        // Verificar si el radiobutton está chequeado
                        if (jQuery('#payment_method_wc_clip_transparent').is(':checked')) {

                            // jQuery( document.body ).trigger( 'update_checkout' );

                            var $button = $(this);
                            $(this).attr('disabled', true);

                            try {
                                const cardTokenPromise = CARD.cardToken();
                                const installments = await CARD.installments();
                                const preventionData = await CARD.preventionData();

                                const timeoutPromise = new Promise((resolve, reject) => {
                                    setTimeout(() => reject(new Error('Tiempo de espera excedido')), 10000);
                                });
                                const cardToken = await Promise.race([cardTokenPromise, timeoutPromise]);

                                if(clip_transparent_object.mode === 'test') console.log(
                                    "%c cardToken!",
                                    "color: blue; font-size: 20px; background-color: yellow;",
                                    cardToken
                                );

                                const tokenCardInput = document.getElementById("clip_transparent_cardtoken");
                                const installmentsCardInput = document.getElementById("clip_transparent_installments");
                                const prevention = document.getElementById("clip_transparent_prevention");

                                tokenCardInput.value = cardToken.id;
                                installmentsCardInput.value = installments;
                                prevention.value = Object.values(preventionData);
                                clip_transparent_error.value = '';

                                $button.closest('form.woocommerce-checkout').submit();
                                jQuery('#place_order').attr('disabled', false);

                            } catch (error) {

                                const clip_transparent_error = document.getElementById("clip_transparent_error");
                                clip_transparent_error.value = error.code;

                                $button.closest('form.woocommerce-checkout').submit();
                                jQuery('#place_order').attr('disabled', false);
                            }
                        } else {
                            // Si el radiobutton no está chequeado, simplemente enviar el formulario sin hacer nada más
                            jQuery(this).closest('form.woocommerce-checkout').submit();
                        }
                    });

                });
            }
        }, 500);
    });
})